SystemOrganization addCategory: #'OpenVolunteerMarketPlace-Model'!
SystemOrganization addCategory: #'OpenVolunteerMarketPlace-View'!
SystemOrganization addCategory: #'OpenVolunteerMarketPlace-Controller'!
SystemOrganization addCategory: #'OpenVolunteerMarketPlace-Tests'!

WAComponent subclass: #OVMPContentView
	instanceVariableNames: 'searchBox projectListView'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenVolunteerMarketPlace-View'!

!OVMPContentView methodsFor: 'initialization' stamp: 'ThiagoFurtado 10/3/2012 12:16'!
initialize 
	super initialize .
	searchBox := OVMPSeachProjectView new.
	projectListView := OVMPProjectListView new.! !

!OVMPContentView methodsFor: 'rendering' stamp: 'ThiagoFurtado 10/3/2012 12:13'!
renderContentOn: html

	html section id: 'content';
		with: [
			html render: searchBox.
			html render: projectListView.
			].! !

WAComponent subclass: #OVMPLoginView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenVolunteerMarketPlace-View'!

!OVMPLoginView methodsFor: 'rendering' stamp: 'ThiagoFurtado 10/3/2012 09:01'!
renderContentOn: html

			html div
				id: 'login';
				with: [
					html form 
					id: 'formlogin';
					with: [
						html fieldSet
							class: 'up';
							with: [
								"html label for: 'email'; with: 'email/username'. "html textInput id: 'email'; type: 'text'; placeholder: 'user/email'.
								"html label for: 'pwd'; with: 'password'." html textInput id: 'pwd';type: 'password'; placeholder: 'password'.
								html submitButton id: 'enter'; class: 'btn'; with: 'Enter'.
								]
						 ].
			].! !

WAComponent subclass: #OVMPNewProjectView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenVolunteerMarketPlace-View'!

!OVMPNewProjectView methodsFor: 'project' stamp: 'ThiagoFurtado 10/3/2012 21:01'!
addProject
	self answer: true.! !

!OVMPNewProjectView methodsFor: 'project' stamp: 'ThiagoFurtado 10/3/2012 20:48'!
cancelAdding
	self answer: false.! !

!OVMPNewProjectView methodsFor: 'rendering' stamp: 'ThiagoFurtado 10/3/2012 15:25'!
renderContentOn: html

	html article
		id: 'projectadding';
		with: [self renderProjectForm: html.]
		
											! !

!OVMPNewProjectView methodsFor: 'rendering' stamp: 'ThiagoFurtado 10/4/2012 00:04'!
renderProjectForm: html

	html article
		id: 'adding';
		with: [ 			
					html form
						id: 'addform';
						with: [ 
									html fieldSet
										class: 'addclass';
										with: [ 
													html textInput
														id: 'projectname';
														type: 'text';
														placeholder: 'Enter a project name'.
													html textInput 
														id: 'projectURL';
														placeholder: 'Enter a URL'.
													html textArea 
														id: 'projectdescription';
														placeholder: 'Enter a description'.
														"rows: 5;
														columns: 100."
													html submitButton 
														id: 'cancelbtn';
														class: 'btn';
														on: #cancelAdding of: self;
														with: 'Cancel'.
													html submitButton 
														id: 'addbtn';
														class: 'btn';
														on: #addProject of: self; 
														with: 'Add'.
												]	
							]				
				]					! !

WAComponent subclass: #OVMPProjectListView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenVolunteerMarketPlace-View'!

!OVMPProjectListView methodsFor: 'rendering' stamp: 'ThiagoFurtado 10/3/2012 13:01'!
renderContentOn: html
	| projects |
	
	"just to test"
	projects := Array new.
	
	html div id: 'list';
		with: [
			
			html unorderedList: [
					projects do: [ :project |
							html listItem: [ html render: project. ].
						]
				]			
			
			].! !

WAComponent subclass: #OVMPProjectView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenVolunteerMarketPlace-View'!

WAComponent subclass: #OVMPSeachProjectView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenVolunteerMarketPlace-View'!

!OVMPSeachProjectView methodsFor: 'accessing' stamp: 'ThiagoFurtado 10/3/2012 14:48'!
addNewProject
	| newProjectView |
	newProjectView := OVMPNewProjectView new.
	
	self call: newProjectView.! !

!OVMPSeachProjectView methodsFor: 'accessing' stamp: 'ThiagoFurtado 10/3/2012 14:38'!
addNewProject: aProject

	self call: (OVMPNewProjectView new yourself)! !

!OVMPSeachProjectView methodsFor: 'rendering' stamp: 'ThiagoFurtado 10/3/2012 21:28'!
renderContentOn: html
	html article
		id: 'projectmgmt';
		with: [self renderFields: html.]
		
											
	! !

!OVMPSeachProjectView methodsFor: 'rendering' stamp: 'ThiagoFurtado 10/3/2012 21:28'!
renderFields: html

	html article
		id: 'search';
		with: [ 			
					html form
						id: 'searchform';
						with: [ 
									html fieldSet
										class: 'searchclass';
										with: [ 
													html submitButton 
														id: 'addproject';
														class: 'btn';
														callback: [self addNewProject ];																
														with: 'New'.
													html textInput
														id: 'projectfield';
														type: 'text';
														placeholder: 'Enter the searching project name'.
													html submitButton
														id: 'enter';
														class: 'btn';
														with: 'Search' ] ] ]! !

WAComponent subclass: #OVMPView
	instanceVariableNames: 'loginComponent centerComponent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenVolunteerMarketPlace-View'!

!OVMPView class methodsFor: 'class initialization' stamp: 'ThiagoFurtado 9/22/2012 14:31'!
initialize

	WAAdmin register: self asApplicationAt: 'openvolunteermarketplace' .! !

!OVMPView methodsFor: 'accessing' stamp: 'ThiagoFurtado 9/29/2012 00:22'!
children 
	^ Array with: loginComponent with: searchProjectBox with: centerComponent.! !

!OVMPView methodsFor: 'initialization' stamp: 'ThiagoFurtado 10/3/2012 12:14'!
initialize 
	super initialize .
	loginComponent := OVMPLoginView new.
	centerComponent := OVMPContentView new.! !

!OVMPView methodsFor: 'rendering' stamp: 'ThiagoFurtado 10/3/2012 12:13'!
renderBodyContentOn: html

	html section id: 'content';
		with: [
			html render: centerComponent.
			].! !

!OVMPView methodsFor: 'rendering' stamp: 'ThiagoFurtado 9/28/2012 23:39'!
renderContentOn: html

	html div 
		id: 'main';
		with: [ self renderHeaderOn: html .
			    self renderBodyContentOn: html ].! !

!OVMPView methodsFor: 'rendering' stamp: 'ThiagoFurtado 10/3/2012 09:02'!
renderHeaderOn: html
	html header
		id: 'header';
		with: [ 
					html div
						id: 'in-header';
						with: [ 
									html heading
										level: 1;
										with: [ 
													html anchor
														url: 'http://localhost:8080/openvolunteermarketplace';
														with: 'Open Volunteer MarketPlace' ].
									self renderLoginForm: html ] ]! !

!OVMPView methodsFor: 'rendering' stamp: 'ThiagoFurtado 9/28/2012 23:48'!
renderLoginForm: html

	html render: loginComponent.! !

!OVMPView methodsFor: 'rendering' stamp: 'pbm 10/5/2012 14:31'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot title: 'Open Volunteer Marketplace'.
	anHtmlRoot stylesheet url: 'http://localhost/openvolunteermarketplace/styles/style.css'! !

TestCase subclass: #DatabaseTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenVolunteerMarketPlace-Tests'!

!DatabaseTestCase methodsFor: 'as yet unclassified' stamp: 'pbm 10/19/2012 19:34'!
setUp
	Database initialize .! !

!DatabaseTestCase methodsFor: 'as yet unclassified' stamp: 'pbm 10/19/2012 19:31'!
testAddAndRemoveVolunteer
	|volunteer collection|
	volunteer :=  (OVMPVolunteer new name: 'name1'; email: 'email1@domain.com'; yourself).
	
	collection := Database create: #volunteer.  
	
	Database at: #volunteer add: volunteer.
	
	self should: [ (Database collection: #volunteer  ) includes: volunteer. ].
	
	Database at: #volunteer remove: volunteer.
	
	self shouldnt: [ (Database collection: #volunteer) includes: volunteer. ].! !

!DatabaseTestCase methodsFor: 'as yet unclassified' stamp: 'pbm 10/19/2012 19:50'!
testFilterVolunteerByName
	|filter volunteer |
	Database create: #volunteer.
	volunteer := OVMPVolunteer new name:'paulo'; email: 'paulo@domain.com'; yourself.
	Database at: #volunteer add:(volunteer ).
	Database at: #volunteer add:(OVMPVolunteer new name:'thiago'; email: 'thiago@domain.com'; yourself ).
	filter := Database at: #volunteer filter: #name by: 'paulo'.
	self should: [filter size = 1].
	self should:[filter includes: volunteer ].! !

!DatabaseTestCase methodsFor: 'as yet unclassified' stamp: 'pbm 10/19/2012 19:40'!
testcreateCollection
	self should: [(Database collection: #volunteer) isNil   ].
	Database create: #volunteer.
	self shouldnt: [(Database collection: #volunteer) isNil ].
! !

TestCase subclass: #InterfaceTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenVolunteerMarketPlace-Tests'!

!InterfaceTestCase methodsFor: 'as yet unclassified' stamp: 'ThiagoFurtado 10/20/2012 14:34'!
testAddNewVolunteer
	|ovmp username users users1|
	
	ovmp := OpenVolunteerMarketplace instance .
	username := 'testVolunteer'. 

	users := (Database at: #volunteer filter: #username by: username).
	self should: [ users isEmpty. ].
	
	ovmp newVolunteer: username.
	
	users1 := (Database at: #volunteer filter: #username by: username).
	self shouldnt: [users1 isEmpty ].
	
	ovmp removeVolunteer: (ovmp volunteer: username ) by: (ovmp volunteer: 'admin').
	
	
	
	
	! !

Object subclass: #Database
	instanceVariableNames: ''
	classVariableNames: 'Collections'
	poolDictionaries: ''
	category: 'OpenVolunteerMarketPlace-Controller'!

!Database class methodsFor: 'accessing' stamp: 'ThiagoFurtado 10/20/2012 13:47'!
addFirstAdmin
	Database at: #volunteer add: (OVMPVolunteer new username: 'admin'; password: 'admin'; admin: true; name: 'Administrator').! !

!Database class methodsFor: 'accessing collections' stamp: 'pbm 10/19/2012 20:57'!
at: aSymbol add: aValue
	^(self collection: aSymbol) add: aValue   ! !

!Database class methodsFor: 'accessing collections' stamp: 'ThiagoFurtado 10/20/2012 13:08'!
at: aSymbol filter: anAttribute by: aValue
	|message collection|
	message := Message new setSelector: anAttribute arguments: #(); yourself .
	collection := self collection: aSymbol.
	^collection select: [:item | (message sendTo: item) = aValue].  
! !

!Database class methodsFor: 'accessing collections' stamp: 'pbm 10/19/2012 19:09'!
at: aSymbol remove: aValue
	(self collection: aSymbol) remove: aValue   ! !

!Database class methodsFor: 'accessing' stamp: 'pbm 10/19/2012 19:37'!
collection: aSymbol
	^Collections at: aSymbol ifAbsent: nil! !

!Database class methodsFor: 'accessing' stamp: 'pbm 10/19/2012 19:30'!
create: aSymbol
	(Collections isNil ) ifTrue: [self initialize ].  
	Collections add: aSymbol -> (Set new).! !

!Database class methodsFor: 'class initialization' stamp: 'pbm 10/19/2012 18:55'!
initialize 
	super initialize .
	Collections := Dictionary new.! !

Object subclass: #OVMPProject
	instanceVariableNames: 'name startDate endDate state tasks coordinators'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenVolunteerMarketPlace-Model'!

!OVMPProject class methodsFor: 'as yet unclassified' stamp: 'pbm 10/19/2012 20:48'!
forName: aName
	^self new name: aName; yourself! !

!OVMPProject methodsFor: 'updating' stamp: 'pbm 10/14/2012 17:46'!
addCoordinator: aVolunteer
	coordinators add: aVolunteer ! !

!OVMPProject methodsFor: 'updating' stamp: 'ThiagoFurtado 9/26/2012 11:14'!
addTask: aTask
	tasks add: aTask.! !

!OVMPProject methodsFor: 'updating' stamp: 'ThiagoFurtado 9/26/2012 11:15'!
addTasks: aTaskArray
	tasks addAll: aTaskArray.! !

!OVMPProject methodsFor: 'accessing' stamp: 'pbm 10/14/2012 17:46'!
coordinators
	^ coordinators ! !

!OVMPProject methodsFor: 'accessing' stamp: 'pbm 10/14/2012 17:43'!
endDate
	^ endDate ! !

!OVMPProject methodsFor: 'updating' stamp: 'pbm 10/14/2012 17:43'!
endDate: aDate
	endDate := aDate! !

!OVMPProject methodsFor: 'initialize-release' stamp: 'pbm 10/14/2012 18:29'!
initialize
	coordinators := Set new.
	tasks := SortedCollection new sort:[:first :second | first startDate <= second startDate ]; yourself .! !

!OVMPProject methodsFor: 'accessing' stamp: 'ThiagoFurtado 9/26/2012 11:12'!
name
	^ name.! !

!OVMPProject methodsFor: 'updating' stamp: 'ThiagoFurtado 9/26/2012 11:12'!
name: aName
	name := aName.! !

!OVMPProject methodsFor: 'updating' stamp: 'pbm 10/14/2012 17:46'!
removeCoordinator: aCoordinator
	coordinators remove: aCoordinator   ! !

!OVMPProject methodsFor: 'accessing' stamp: 'ThiagoFurtado 9/26/2012 11:13'!
startDate
	^ startDate.! !

!OVMPProject methodsFor: 'updating' stamp: 'ThiagoFurtado 9/26/2012 11:12'!
startDate: aDate
	startDate := aDate.! !

!OVMPProject methodsFor: 'accessing' stamp: 'pbm 10/14/2012 17:44'!
state
	^ state! !

!OVMPProject methodsFor: 'updating' stamp: 'pbm 10/14/2012 17:44'!
state: aState
	state := aState ! !

!OVMPProject methodsFor: 'accessing' stamp: 'ThiagoFurtado 9/26/2012 11:13'!
tasks
	^ tasks.! !

Object subclass: #OVMPProjectController
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenVolunteerMarketPlace-Controller'!

!OVMPProjectController methodsFor: 'accessing' stamp: 'ThiagoFurtado 10/3/2012 12:47'!
projects
	! !

Object subclass: #OVMPSkill
	instanceVariableNames: 'name description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenVolunteerMarketPlace-Model'!

!OVMPSkill class methodsFor: 'as yet unclassified' stamp: 'pbm 10/14/2012 19:08'!
forDescription: aDescription
	self new description: aDescription ; yourself   ! !

!OVMPSkill methodsFor: 'accessing' stamp: 'ThiagoFurtado 10/20/2012 15:47'!
description
	^ description.! !

!OVMPSkill methodsFor: 'accessing' stamp: 'ThiagoFurtado 10/20/2012 15:47'!
description: aDescription
	description := aDescription.! !

!OVMPSkill methodsFor: 'accessing' stamp: 'ThiagoFurtado 10/20/2012 15:47'!
name
	^ name.! !

!OVMPSkill methodsFor: 'accessing' stamp: 'ThiagoFurtado 10/20/2012 15:47'!
name: aName
	name := aName.! !

Object subclass: #OVMPTask
	instanceVariableNames: 'name volunteers skills candidates startDate state estimatedDuration estimatedConclusionDate endDate project'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenVolunteerMarketPlace-Model'!

!OVMPTask class methodsFor: 'instance creation' stamp: 'pbm 10/14/2012 18:53'!
forProject: aProject startingAt: aDate
	aProject addTask: (self new startDate: aDate; yourself)! !

!OVMPTask methodsFor: 'updating' stamp: 'pbm 10/14/2012 18:03'!
addCandidate: aVolunteer
	candidates add: aVolunteer   ! !

!OVMPTask methodsFor: 'updating' stamp: 'pbm 10/14/2012 18:02'!
addSkill: aSkill
	skills add: aSkill     ! !

!OVMPTask methodsFor: 'updating' stamp: 'pbm 10/14/2012 17:59'!
addVolunteer: aVolunteer
	volunteers add: aVolunteer   ! !

!OVMPTask methodsFor: 'accessing' stamp: 'pbm 10/14/2012 17:58'!
candidates 
	^ candidates ! !

!OVMPTask methodsFor: 'initialize-release' stamp: 'pbm 10/14/2012 18:16'!
initialize 
	volunteers := Set new.
	candidates := Set new.
	skills := Set new.! !

!OVMPTask methodsFor: 'accessing' stamp: 'pbm 10/14/2012 17:56'!
name
	^ name! !

!OVMPTask methodsFor: 'updating' stamp: 'pbm 10/14/2012 17:49'!
name: aName
	name := aName! !

!OVMPTask methodsFor: 'accessing' stamp: 'ThiagoFurtado 10/20/2012 12:20'!
project
	^ project.! !

!OVMPTask methodsFor: 'accessing' stamp: 'ThiagoFurtado 10/20/2012 12:20'!
project: aProject
	project := aProject .! !

!OVMPTask methodsFor: 'updating' stamp: 'pbm 10/14/2012 18:05'!
removeCandidate: aVolunteer
	candidates remove: aVolunteer ! !

!OVMPTask methodsFor: 'updating' stamp: 'pbm 10/14/2012 18:02'!
removeSkill: aSkill
	skills remove: aSkill   ! !

!OVMPTask methodsFor: 'updating' stamp: 'pbm 10/14/2012 18:00'!
removeVolunteer: aVolunteer
	volunteers remove: aVolunteer   ! !

!OVMPTask methodsFor: 'testing' stamp: 'pbm 10/14/2012 21:44'!
requiresSkill: aSkill
	^skills includes: aSkill     ! !

!OVMPTask methodsFor: 'accessing' stamp: 'pbm 10/14/2012 18:01'!
skills
	^ skills ! !

!OVMPTask methodsFor: 'accessing' stamp: 'pbm 10/14/2012 18:33'!
startDate
	^ startDate ! !

!OVMPTask methodsFor: 'updating' stamp: 'pbm 10/14/2012 18:34'!
startDate: aDate
	startDate := aDate ! !

!OVMPTask methodsFor: 'accessing' stamp: 'pbm 10/14/2012 17:57'!
volunteers
	^ volunteers ! !

Object subclass: #OVMPVolunteer
	instanceVariableNames: 'username password email name birthday skills admin'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenVolunteerMarketPlace-Model'!

!OVMPVolunteer class methodsFor: 'instance creation' stamp: 'pbm 10/19/2012 20:33'!
forUsername: aUsername
	^self new username: aUsername; yourself.! !

!OVMPVolunteer methodsFor: 'updating' stamp: 'ThiagoFurtado 9/26/2012 13:11'!
addSkill: aSkill
	skills add: aSkill.! !

!OVMPVolunteer methodsFor: 'updating' stamp: 'ThiagoFurtado 9/26/2012 13:12'!
addSkills: aSkillArray
	 skills addAll: aSkillArray.! !

!OVMPVolunteer methodsFor: 'initialize-release' stamp: 'ThiagoFurtado 10/20/2012 13:46'!
admin: aBoolean
	admin := aBoolean.! !

!OVMPVolunteer methodsFor: 'accessing' stamp: 'pbm 10/14/2012 19:12'!
email 
	^email ! !

!OVMPVolunteer methodsFor: 'updating' stamp: 'pbm 10/14/2012 19:13'!
email: anEmail
 email := anEmail ! !

!OVMPVolunteer methodsFor: 'testing' stamp: 'pbm 10/14/2012 21:45'!
hasSkill: aSkill
	^ skills includes: aSkill   ! !

!OVMPVolunteer methodsFor: 'initialize-release' stamp: 'ThiagoFurtado 10/20/2012 13:45'!
initialize 
	skills := Set new.! !

!OVMPVolunteer methodsFor: 'initialize-release' stamp: 'ThiagoFurtado 10/20/2012 13:46'!
isAdmin
	^ admin.! !

!OVMPVolunteer methodsFor: 'accessing' stamp: 'pbm 10/14/2012 17:28'!
name
	"get person's name"
	^ name.! !

!OVMPVolunteer methodsFor: 'updating' stamp: 'pbm 10/14/2012 17:28'!
name: aName
	"set person's name"
	name := aName.! !

!OVMPVolunteer methodsFor: 'accessing' stamp: 'pbm 10/14/2012 19:11'!
password 
	^ password ! !

!OVMPVolunteer methodsFor: 'updating' stamp: 'pbm 10/14/2012 19:12'!
password: aPassword
	password := aPassword ! !

!OVMPVolunteer methodsFor: 'updating' stamp: 'pbm 10/14/2012 19:13'!
removeSkill: aSkill
	skills remove: aSkill     ! !

!OVMPVolunteer methodsFor: 'accessing' stamp: 'ThiagoFurtado 9/26/2012 13:11'!
skills
	^ skills.! !

!OVMPVolunteer methodsFor: 'accessing' stamp: 'pbm 10/14/2012 19:11'!
username
	^ username ! !

!OVMPVolunteer methodsFor: 'updating' stamp: 'pbm 10/14/2012 17:29'!
username: aUsername
	"set person's username"

	username := aUsername.! !

Object subclass: #OpenVolunteerMarketplace
	instanceVariableNames: ''
	classVariableNames: 'instance'
	poolDictionaries: ''
	category: 'OpenVolunteerMarketPlace-Controller'!

!OpenVolunteerMarketplace class methodsFor: 'as yet unclassified' stamp: 'ThiagoFurtado 10/20/2012 13:10'!
instance
	instance isNil ifTrue: [instance := super new. instance initialize].
	^ instance ! !

!OpenVolunteerMarketplace class methodsFor: 'as yet unclassified' stamp: 'pbm 10/19/2012 19:58'!
new
	super error: 'This is a slingleton'.! !

!OpenVolunteerMarketplace methodsFor: 'as yet unclassified' stamp: 'ThiagoFurtado 10/20/2012 12:59'!
hasUser: anUsername
	 (Database at: #volunteer filter: #username by: anUsername ) isEmpty 
		ifTrue: [ ^ false. ] ifFalse: [^ true].! !

!OpenVolunteerMarketplace methodsFor: 'initialize-release' stamp: 'ThiagoFurtado 10/20/2012 13:30'!
initialize 
	Database initialize.
	Database create: #volunteer.
	Database create: #project.
	Database create: #task.
	Database create: #skill.
	Database addFirstAdmin.! !

!OpenVolunteerMarketplace methodsFor: 'accessing' stamp: 'ThiagoFurtado 10/20/2012 11:28'!
newCoordinator: aCoordinator for: aProject
	|coordinator tmpProject|
	tmpProject := (Database at: #project filter: #name by: ( aProject name ) ).
	(tmpProject isEmpty)
		ifTrue: [
			self error: 'There is no project with name ', ( aProject name ). 
			]	
		ifFalse: [
			( Database at: #project filter: #name by: ( aProject name ) ) addCoordinator: aCoordinator .
			]
! !

!OpenVolunteerMarketplace methodsFor: 'accessing' stamp: 'pbm 10/19/2012 20:53'!
newProject: aName with: aCoordinator
	|project|
	(Database at: #project filter: #name by: aName) isEmpty
		ifTrue: [
			project := OVMPProject forName: aName.
			project addCoordinator: aCoordinator.  
			Database at: #project add: project ]
		ifFalse:   [
			self error: 'project alreary exists'].
	^project ! !

!OpenVolunteerMarketplace methodsFor: 'accessing' stamp: 'ThiagoFurtado 10/20/2012 12:22'!
newRequiredSkill: skill for: aTask addBy: aCoordinator 
	|tmpTask|
	tmpTask := (Database at: #task filter: #name by: ( aTask name  ) ).
	( tmpTask isEmpty ) 
		ifTrue: [
			self error: 'There is no task named ', aTask name.] 
		ifFalse: [
			(( tmpTask project coordinators ) includes: aCoordinator ) ifTrue: [
			( Database at: #task filter: #name by: (aTask name) ) addSkill: skill ]
			ifFalse: [ self error: aCoordinator , ' have no permissions to add skills.'] ] ! !

!OpenVolunteerMarketplace methodsFor: 'accessing' stamp: 'ThiagoFurtado 10/20/2012 15:48'!
newSkill: aSkill addBy: aVolunteer
	"If aVolunteer is an admin, the skill is add to default level and all users can see it. Otherwise the skill is visible only in the scope of the projet its belong"
	
	(aVolunteer isAdmin )
		ifTrue: [ 
			Database at: #skill add: ( aSkill ) ] 
	! !

!OpenVolunteerMarketplace methodsFor: 'accessing' stamp: 'pbm 10/19/2012 20:55'!
newTaskFor: aProject
	|task|
	task := OVMPTask new.
	aProject addTask: task.
	^Database at: #task add: task.  ! !

!OpenVolunteerMarketplace methodsFor: 'accessing' stamp: 'pbm 10/19/2012 20:34'!
newVolunteer: aUsername
	|volunteer|
	 (Database at: #volunteer filter: #username by: aUsername) isEmpty 
		ifFalse: [
				self error:'username aready in use.'] 
		ifTrue: [
				volunteer := OVMPVolunteer forUsername: aUsername.
				Database at: #volunteer add: volunteer].
	^volunteer    ! !

!OpenVolunteerMarketplace methodsFor: 'accessing' stamp: 'ThiagoFurtado 10/20/2012 15:11'!
removeSkill: aSkill by: aVolunteer
	
	( aVolunteer isAdmin )
		ifTrue: [ ]! !

!OpenVolunteerMarketplace methodsFor: 'as yet unclassified' stamp: 'ThiagoFurtado 10/20/2012 13:28'!
removeVolunteer: aVolunteer by: me
	"only me or admin can remove from application"
	(aVolunteer = me) 
		ifTrue: [
			Database at: #volunteer remove: aVolunteer. ]
		ifFalse: [
			(me isAdmin) 
				ifTrue: [ 
					Database at: #volunteer remove: aVolunteer. ] 
				ifFalse: 
					[ "You can only remove yourself " ] ]
! !

!OpenVolunteerMarketplace methodsFor: 'as yet unclassified' stamp: 'ThiagoFurtado 10/20/2012 13:28'!
removeVolunteerFromProject: aProject by: me
	"Only me, coordinator, or admin can remove from porject"! !

!OpenVolunteerMarketplace methodsFor: 'as yet unclassified' stamp: 'ThiagoFurtado 10/20/2012 14:25'!
volunteer: anUsername
	|users user|
	users := (Database at: #volunteer filter: #username by: anUsername).
	
	( users isEmpty ) ifTrue: [  ]
		ifFalse: [ users select: [:item | (item username = anUsername) ifTrue: [ ^ item ] ]  ]
		
	
	! !
OVMPView initialize!
Database initialize!
